<?php
// Part of Point payment module
// catch post message from Point payment system
// in case there is a session, redirect to the shop payment system
// if no session exists this is late return from the 
// payment system and we send information email to the shop owner

define('LANGUAGE_DIR','english/');  // language directory

require('includes/application_top.php');
include(DIR_WS_LANGUAGES . LANGUAGE_DIR . 'modules/payment/point.php');


if(!empty($_SESSION['cart']->contents)) {

  $target_url = zen_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL');
 
  $html = '<html><form action="'. $target_url .'" method="POST" id="forward" >';
  foreach($_POST as $key => $value) {
    $html .= "<input type=\"hidden\" name=\"$key\" value=\"$value\" />\n";
  }
  $html.= '<script type="text/javascript">document.getElementById("forward").submit();</script>'; 
  $html .= '<input type="submit" value="' . MODULE_PAYMENT_POINT_FORWARD_SUBMIT . '" /></html>';
  
  echo $html;
} else {

  if(!isset($_POST['s-f-1-36_order-number'])) { 
  // do nothing
    header('200 OK');
    die('No data to process.');
  }

  unset($_POST["s-t-1-40_shop-receipt__phase"]);
    $signedformdata = $_POST;
    $renderdata = $_POST;
    unset($signedformdata["s-t-256-256_signature-one"]);
    unset($signedformdata["s-t-256-256_signature-two"]);  
   
  $signature_valid = verifysignature(formatparameters($signedformdata), $_POST["s-t-256-256_signature-one"]);


   $payment_id = (int) $_POST['s-f-1-36_order-number'];
   $transaction_number = preg_replace("/[[:^digit:]]/", '', $_POST['l-f-1-20_transaction-number']);

  
   $sql = "UPDATE point_payments SET transaction_number = '" . 
           mysql_real_escape_string($transaction_number) . 
            "' , time_processed = NOW() WHERE payment_id = '" . (int) $payment_id .
            "' AND time_processed = '0000-00-00 00:00:00'"; 

  $result = mysql_query($sql);

  if($signature_valid and mysql_affected_rows() == 0) {
    // payment handled already
    header('200 OK');
    die('Payment processed already.'); 
  }

 
  $sql = "SELECT customer_id, total_sum FROM point_payments WHERE payment_id = '" . (int) $payment_id . "'";
  $result = mysql_query($sql);
  $row = mysql_fetch_assoc($result);
  $sum_in_db = $row['total_sum'];
  $customer_id = $row['customer_id'];
  
   if(!$signature_valid or
     empty($transaction_number) or
      $_POST['l-f-1-20_order-gross-amount'] != $sum_in_db) {
    header('403 Forbidden');
    die('403 Forbidden');
  }



  // notify store owner by email
  mail(STORE_OWNER_EMAIL_ADDRESS, MODULE_PAYMENT_POINT_NOTIFICATION_EMAIL_SUBJECT, sprintf(MODULE_PAYMENT_POINT_NOTIFICATION_EMAIL_BODY, $customer_id,($sum_in_db/100)), "From: " . EMAIL_FROM);
  
  // signal OK to Point payment
  header('200 OK');
  die('200 OK');


// handle late post
}


 function formatparameters($parameters) {
   ksort($parameters, SORT_STRING);
   $formatedresult = "";
  foreach ($parameters as $key => $value)  {
    $value = str_replace(';',';;',$value);
    $formatedresult .= sprintf("%s=%s;", $key, $value);
  }
  return $formatedresult;
 }

 function verifysignature($datatoverify, $signaturedata) {
    set_include_path(get_include_path() . PATH_SEPARATOR . DIR_FS_CATALOG . DIR_WS_MODULES . 'payment/');
    $key = file_get_contents(MODULE_PAYMENT_POINT_PUBLIC_KEY, true);

    if(!$key) { 
      error_log('Point payment: Could not read keyfile.');
     return false; }

    require('Crypt/RSA.php');
    $rsa = new Crypt_RSA();
 
    $rsa->setSignatureMode(CRYPT_RSA_SIGNATURE_PKCS1);
    $rsa->loadKey($key);
    return $rsa->verify($datatoverify, pack("H*" , $signaturedata)) ? true : false;
  }

?>

